Package net.sf.saxon.expr.sort

## Class GroupByIterator

- java.lang.Object
- - net.sf.saxon.expr.sort.GroupByIterator

- All Implemented Interfaces:
    `java.io.Closeable`, `java.lang.AutoCloseable`, `LastPositionFinder`, `GroupIterator`, `SequenceIterator`, `LookaheadIterator`

      public class GroupByIterator
      extends java.lang.Object
      implements GroupIterator, LastPositionFinder, LookaheadIterator

  A GroupByIterator iterates over a sequence of groups defined by xsl:for-each-group group-by="x". The groups are returned in order of first appearance. Note that an item can appear in several groups; indeed, an item may be the leading item of more than one group, which means that knowing the leading item is not enough to know the current group.

  The GroupByIterator acts as a SequenceIterator, where successive calls of next() return the leading item of each group in turn. The current item of the iterator is therefore the leading item of the current group. To get access to all the members of the current group, the method iterateCurrentGroup() is used; this underpins the current-group() function in XSLT. The grouping key for the current group is available via the getCurrentGroupingKey() method.

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class | Description
    --- | --- | ---
    `class` | `GroupByIterator.ManualGroupByIterator` |

    - ### Nested classes/interfaces inherited from interface net.sf.saxon.om.SequenceIterator

      `SequenceIterator.Property`

  - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `protected boolean` | `composite` |
    `protected java.util.List<AtomicSequence>` | `groupKeys` |
    `protected java.util.List<java.util.List<Item>>` | `groups` |
    `protected Expression` | `keyExpression` |

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `GroupByIterator()` |
    `GroupByIterator​(SequenceIterator population, Expression keyExpression, XPathContext keyContext, StringCollator collator, boolean composite)` | Create a GroupByIterator

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `java.util.List` | `getCurrentGroup()` | Get the contents of the current group as a java List
    `AtomicSequence` | `getCurrentGroupingKey()` | Get the value of the grouping key for the current group
    `int` | `getLength()` | Get the last position (that is, the number of groups)
    `java.util.EnumSet<SequenceIterator.Property>` | `getProperties()` | Get properties of this iterator, as a bit-significant integer.
    `ManualGroupIterator` | `getSnapShot​(XPathContext context)` | Get a sequence which is a snapshot of this sequence at the current position
    `boolean` | `hasNext()` | Determine whether there are more items to come.
    `SequenceIterator` | `iterateCurrentGroup()` | Get an iterator over the items in the current group
    `Item` | `next()` | Get the next item in the sequence.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface net.sf.saxon.om.SequenceIterator

      `close, forEachOrFail, materialize`

- - ### Field Detail

    - #### keyExpression

          protected Expression keyExpression

    - #### groups

          protected java.util.List<java.util.List<Item>> groups

    - #### groupKeys

          protected java.util.List<AtomicSequence> groupKeys

    - #### composite

          protected boolean composite

  - ### Constructor Detail

    - #### GroupByIterator

          public GroupByIterator​(SequenceIterator population,
                                 Expression keyExpression,
                                 XPathContext keyContext,
                                 StringCollator collator,
                                 boolean composite)
                          throws XPathException

      Create a GroupByIterator
      Parameters:
        `population` - iterator over the population to be grouped
        `keyExpression` - the expression used to calculate the grouping key
        `keyContext` - dynamic context for calculating the grouping key
        `collator` - Collation to be used for comparing grouping keys
        `composite` - true if grouping keys are to be treated as composite keys
      Throws:
        `XPathException` - if an error occurs

    - #### GroupByIterator

          public GroupByIterator()

  - ### Method Detail

    - #### getCurrentGroupingKey

          public AtomicSequence getCurrentGroupingKey()

      Get the value of the grouping key for the current group
      Specified by:
        `getCurrentGroupingKey` in interface `GroupIterator`
      Returns:
        the grouping key

    - #### iterateCurrentGroup

          public SequenceIterator iterateCurrentGroup()

      Get an iterator over the items in the current group
      Specified by:
        `iterateCurrentGroup` in interface `GroupIterator`
      Returns:
        the iterator

    - #### getCurrentGroup

          public java.util.List getCurrentGroup()

      Get the contents of the current group as a java List
      Returns:
        the contents of the current group

    - #### hasNext

          public boolean hasNext()

      Description copied from interface: `LookaheadIterator`
      Determine whether there are more items to come. Note that this operation is stateless and it is not necessary (or usual) to call it before calling next(). It is used only when there is an explicit need to tell if we are at the last element.

      This method must not be called unless the result of getProperties() on the iterator includes the property `SequenceIterator.Property.LOOKAHEAD`

      Specified by:
        `hasNext` in interface `LookaheadIterator`
      Returns:
        true if there are more items in the sequence

    - #### next

          public Item next()
                    throws XPathException

      Description copied from interface: `SequenceIterator`
      Get the next item in the sequence. This method changes the state of the iterator.
      Specified by:
        `next` in interface `SequenceIterator`
      Returns:
        the next item, or null if there are no more items. Once a call on next() has returned null, no further calls should be made. The preferred action for an iterator if subsequent calls on next() are made is to return null again, and all implementations within Saxon follow this rule.
      Throws:
        `XPathException` - if an error occurs retrieving the next item

    - #### getProperties

          public java.util.EnumSet<SequenceIterator.Property> getProperties()

      Get properties of this iterator, as a bit-significant integer.
      Specified by:
        `getProperties` in interface `SequenceIterator`
      Returns:
        the properties of this iterator. This will be some combination of properties such as `SequenceIterator.Property.GROUNDED`, `SequenceIterator.Property.LAST_POSITION_FINDER`, and `SequenceIterator.Property.LOOKAHEAD`. It is always acceptable to return the value zero, indicating that there are no known special properties. It is acceptable for the properties of the iterator to change depending on its state.

    - #### getLength

          public int getLength()
                        throws XPathException

      Get the last position (that is, the number of groups)
      Specified by:
        `getLength` in interface `LastPositionFinder`
      Returns:
        the number of items in the sequence
      Throws:
        `XPathException` - if an error occurs evaluating the sequence in order to determine the number of items

    - #### getSnapShot

          public ManualGroupIterator getSnapShot​(XPathContext context)

      Description copied from interface: `GroupIterator`
      Get a sequence which is a snapshot of this sequence at the current position
      Specified by:
        `getSnapShot` in interface `GroupIterator`